#if defined(unix) || defined(__unix__)
#include <time.h>
#include <sys/time.h>

#else	/* assume win32 */
#include <windows.h>

#endif	/* defined(unix) || defined(__unix__) */

#include "timer.h"


static unsigned long sys_get_msec(void) {
#if defined(unix) || defined(__unix__)
	struct timeval tv;
	
	gettimeofday(&tv, 0);
	return tv.tv_sec * 1000 + tv.tv_usec / 1000;
#else
	return GetTickCount();
#endif
}


void timer_start(ntimer *timer) {
	timer->state = TSTATE_RUNNING;
	timer->start += timer->stop - sys_get_msec();
	timer->stop = 0;
}

void timer_stop(ntimer *timer) {
	timer->state = TSTATE_PAUSED;
	timer->stop = sys_get_msec();
}

void timer_reset(ntimer *timer) {
	timer->state = TSTATE_RESET;
	timer->start = sys_get_msec();
	timer->stop = 0;	
}

unsigned long timer_getmsec(const ntimer *timer) {
	return sys_get_msec() - timer->start;
}

unsigned long timer_getsec(const ntimer *timer) {
	return (sys_get_msec() - timer->start) / 1000;
}
