#ifndef _TIMER_H_
#define _TIMER_H_

#ifdef __cplusplus
extern "C" {
#endif	/* __cplusplus */

enum timer_state {TSTATE_RUNNING, TSTATE_PAUSED, TSTATE_RESET};

typedef struct ntimer {
	unsigned long stop, start;
	enum timer_state state;
} ntimer;

/* note: always call timer_reset() before anything else */

void timer_start(ntimer *timer);
void timer_stop(ntimer *timer);
void timer_reset(ntimer *timer);
unsigned long timer_getmsec(const ntimer *timer);
unsigned long timer_getsec(const ntimer *timer);

#ifdef __cplusplus
}
#endif	/* __cplusplus */

#endif	/* _TIMER_H_ */
